//********************************* Mouse ****************************
void mousePressed() { 
    Pave paveMouse;
    
    if (affiche_grille) {                                                                                                                         //  la grille est affichee
        if (!mode_selection) {                                                                                                                    //------------------------ on n'est PAS dans le mode sélection
            //------------ positions de la souris dans un pavé --------------
            //                    ┌───┬───┬───┐
            //                    │ 0 │ 1 │ 2 │
            //                    ├───┼───┼───┤
            //                    │ 3 │ 4 │ 5 │
            //                    ├───┼───┼───┤
            //                    │ 6 │ 7 │ 8 │
            //                    └───┴───┴───┘                        
            
            palette.test_palette();
            if (!palette.in_palette) {                                                                                                            //----------  on n'est PAS dans la palette
                c_mouse = int((x_mouse-bordure_x)/MAILLE/zoom_x-c_min);
                l_mouse = int((y_mouse-bordure_y)/MAILLE/zoom_y-l_min+niveau*L_MAX);
                int sub_x = (x_mouse-bordure_x)*3/MAILLE/zoom_x;
                int sub_y = (y_mouse-bordure_y)*3/MAILLE/zoom_y;
                int box   = 0;

                if ((sub_x)%3 == 0 && (sub_y)%3 == 0) box = 0;
                if ((sub_x)%3 == 1 && (sub_y)%3 == 0) box = 1;
                if ((sub_x)%3 == 2 && (sub_y)%3 == 0) box = 2;
                if ((sub_x)%3 == 0 && (sub_y)%3 == 1) box = 3;
                if ((sub_x)%3 == 1 && (sub_y)%3 == 1) box = 4;
                if ((sub_x)%3 == 2 && (sub_y)%3 == 1) box = 5;
                if ((sub_x)%3 == 0 && (sub_y)%3 == 2) box = 6;
                if ((sub_x)%3 == 1 && (sub_y)%3 == 2) box = 7;
                if ((sub_x)%3 == 2 && (sub_y)%3 == 2) box = 8;

                paveMouse = tco.paves[c_mouse][l_mouse];
                if (paveMouse == null) return;
                if (mouseButton == LEFT && box == 6) {                                                                                            //---------------  rotation horaire
                    paveMouse.orientation = (paveMouse.orientation+7-1)%8+1;                                                                      //  memorisation de l'orientation du pavé
                }
                if (mouseButton == LEFT && box == 8) {                                                                                            //---------------  rotation trigo
                    paveMouse.orientation = (paveMouse.orientation+7+1)%8+1;                                                                      //  memorisation de l'orientation du pavé
                }
                if (mouseButton == LEFT && box < 6) {                                                                                             //---------------  on ne bouge qu'un seul pavé
                    if (paveMouse.ID_zone.equals("_")) {
                        if (paveMouse.type == 12) {                                                                                               //  si on est sur le pont tournant ...
                            if (pont_compte_voies != 0) {                                                                                         //  ... et qu'on n'a pas de voies de pont, on peut bouger le pont                                                                                                            //  alert message
                                showMessageDialog(null, "Il est impossible de déplacer le pont tournant seul s'il a des voies"+
                                               char(10)+"Utilisez le déplacement du pont tournant AVEC ses voies",
                                                        "Attention", ERROR_MESSAGE);
                            } else {
                                mouseButton_test(c_mouse, l_mouse);
                                deplacement = true;
                                sauve       = false;
                                paves_volants.clear();
                                paves_volants.add(paveMouse);
                            }
                        } else {
                            mouseButton_test(c_mouse, l_mouse);
                            deplacement = true;
                            sauve       = false;
                            paves_volants.clear();
                            paves_volants.add(paveMouse);
                        }
                    } else {
                        showMessageDialog(null, "On ne peut pas déplacer un pavé seul s'il appartient à une zone déjà définie"+
                                       char(10)+"Effacez d'abord les identifiants de la zone concernée",
                                                "Attention", ERROR_MESSAGE);
                    }
                }
                if (mouseButton == RIGHT && box == 7) {                                                                                           //----------------  nettoyage d'un seul pavé
                    if (paveMouse.type == 12) {
                        if (pont_compte_voies != 0) {                                                                                             //  ... et qu'on n'a pas de voies de pont, on peut bouger le pont                                                                                                            //  alert message
                            showMessageDialog(null, "Il est impossible d'effacer le pont tournant seul s'il a des voies"+
                                           char(10)+"Effacez le pont tournant AVEC ses voies",
                                                    "Attention", ERROR_MESSAGE);
                        } else {
                            pavePont              = null;
                            etiquettes_pont       = false;
                            pont_tournant_pose    = false;
                            paveMouse.selectionne = true;
                            nettoyage             = true;
                            deplacement           = false;
                            sauve                 = false;
                        }
                    } else {
                        paveMouse.selectionne = true;
                        nettoyage             = true;
                        deplacement           = false;
                        sauve                 = false;
                    }
                    one_shot = true;
                }
                if (mouseButton == RIGHT && box == 6) {                                                                                           //---------------  rotation horaire
                    theta = theta-0.0130899F;                                                                                                     //  memorisation de l'orientation du pavé
                }
                if (mouseButton == RIGHT && box == 8) {                                                                                           //---------------  rotation trigo
                    theta = theta+0.0130899F;                                                                                                     //  memorisation de l'orientation du pavé
                }
                one_shot = true;
                if (mouseButton == RIGHT && box < 6 && paveMouse.appareil_de_voie) {
                    int reponse = -1;
                    Object[] options = { "30 km/h", "60 km/h", "160 km/h", "Pas de limite" };
                    reponse = showOptionDialog(null, "Choisissez la limite de vitesse sur voie déviée pour cet appareil de voie",        
                                                     "Choisissez",
                                                     DEFAULT_OPTION, QUESTION_MESSAGE,
                                                     null, options, options[0]);
                    switch (reponse) {
                        case 0 :
                            paveMouse.vitesse_deviee = 30;
                            break;
                        case 1 :
                            paveMouse.vitesse_deviee = 60;
                            break;
                        case 2 :
                            paveMouse.vitesse_deviee = 160;
                            break;
                        case 3 :
                            paveMouse.vitesse_deviee = 1000;
                    }                                
                }
                if (mouseButton == RIGHT && box < 6 && (paveMouse.butoir[0] || paveMouse.butoir[1])) {
                    int reponse = -1;
                    Object[] options = { "Magenta", "Rouge" };
                    reponse = showOptionDialog(null, "Choisissez la couleur du feu de butoir",        
                                                     "Choisissez",
                                                     DEFAULT_OPTION, QUESTION_MESSAGE,
                                                     null, options, options[0]);
                    switch (reponse) {
                        case 0 :
                            paveMouse.couleur_butoir = false;
                            break;
                        case 1 :
                            paveMouse.couleur_butoir = true;
                            break;
                    }                                
                }
            } else {                                                                                                                              //-------------------  on est DANS la palette
                palette.pave_in_palette(); 
            }
        } else {                                                                                                                                  //  on est dans le mode sélection
            //---------------------------------------------------------------------------- MODE SELECTION -------------------------------------------------------------------------------------------------------------------
            x_precedent = mouseX;                                                                                                                 //  mémorisation des x/y de la souris
            y_precedent = mouseY;
            
            palette.test_palette();
            if (palette.in_palette) {                                                                                                             //-------------------  on est DANS la palette
                palette.pave_in_palette();
            } else {                                                                                                                              //-------------------  on n'est PAS dans la palette
                c_mouse   = int((x_precedent-bordure_x)/MAILLE/zoom_x-c_min);                                                                     //  c_mouse et l_mouse sont les colones/ligne de la souris
                l_mouse   = int((y_precedent-bordure_y)/MAILLE/zoom_y-l_min+niveau*L_MAX);
                paveMouse = tco.paves[c_mouse][l_mouse];                                                                                          //  paveMouse est le pavé de la souris
                if (paveMouse != null) {
                    //---------------------------- FlexibleSgauche ou droit ----------------------------------
                    if (!mode_flexible && (paveMouse.type == 5 || paveMouse.type == 6) && mouseButton == LEFT) {                                  //  mise a jour la première fois qu'on sélectionne le pavé flexible
                        c_info_pave           = c_mouse;                                                                                          //  les infos (longueur/hauteur) seront rangées dans le pavé identifié par c_info_pave et l_info_pave 
                        l_info_pave           = l_mouse;
                        mode_flexible         = true;
                        paveMouse.selectionne = true;
                    }
                    //----------------------------- Voie pont tournant -----------------------------------
                    if (!voie_pont_tournant_posee && paveMouse.type == 11 && mouseButton == LEFT) {                                               //  mise a jour la première fois qu'on sélectionne le pavé voie de pont
                        c_info_pave              = c_mouse;
                        l_info_pave              = l_mouse;
                        voie_pont_tournant_posee = true;
                        paveMouse.selectionne    = true;                        
                        paveMouse.orientation    = (12-int((paveMouse.ordre-1)/(max_ordre/8))) % 8 + 1;                                           //  il ne s'agit pas ici d'une véritable orientation : c'est le cadran dans lequel est la voie de pont //<>//
                    }
                    //---------------------------- Pont tournant ----------------------------------
                    if (!pont_tournant_pose && paveMouse.type == 12 && mouseButton == LEFT) {
                        pont_tournant_pose    = true;                        
                        paveMouse.selectionne = true;                        
                        mode_selection        = false;
                        one_shot              = true;
                        cursor(ARROW);
                    }
                }
            }
        }
    }
}

//************************************ mouseDragged() *************************************  
void mouseDragged() {   
    if(mode_selection && !palette.in_palette) { 
        noFill();
        for (int x = 0; x < width; x = x+MAILLE*zoom_x) {                                                                                         //  La souris va du haut a gauche au bas a droite
            int c = int(x/MAILLE/zoom_x-1-c_min);
            for (int y = 0; y < height; y = y+MAILLE*zoom_y) {
                int l = int(y/MAILLE/zoom_y-1-l_min);
                if ((x+bordure_x >= x_precedent) && (x+bordure_x <= mouseX+MAILLE*zoom_x) 
                 && (y+bordure_y >= y_precedent) && (y+bordure_y <= mouseY+MAILLE*zoom_y))
                {
                    mouseButton_test(c,l+niveau*L_MAX);
                }
            }
        }
        for (int x = 0; x < width; x = x+MAILLE*zoom_x) {                                                                                         //  La souris va du bas a gauche au haut a droite
            int c = int(x/MAILLE/zoom_x-1-c_min);
            for (int y = 0; y < height; y = y+MAILLE*zoom_y) {
                int l = int(y/MAILLE/zoom_y-l_min);
                if ((x+bordure_x >= x_precedent) && (x+bordure_x <= mouseX+MAILLE*zoom_x) 
                  && (y+bordure_y <= y_precedent) && (y+bordure_y >= mouseY-MAILLE*zoom_y))
                {
                    mouseButton_test(c,l+niveau*L_MAX);
                }
            }
        }
        for (int x = 0; x < width; x = x+MAILLE*zoom_x) {                                                                                         //  La souris va du haut a droite au bas a gauche
        int c = int(x/MAILLE/zoom_x-c_min);
            for (int y = 0; y < height; y = y+MAILLE*zoom_y) {
                int l = int(y/MAILLE/zoom_y-1-l_min);
                if ((x+bordure_x <= x_precedent) && (x+bordure_x >= mouseX-MAILLE*zoom_x)
                 && (y+bordure_y >= y_precedent) && (y+bordure_y <= mouseY+MAILLE*zoom_y))
                {
                    mouseButton_test(c,l+niveau*L_MAX);
                }
            }
        }
        for (int x = 0; x < width; x = x+MAILLE*zoom_x) {                                                                                         //  La souris va du bas a droite au haut a gauche
            int c = int(x/MAILLE/zoom_x-c_min);
            for (int y = 0; y < height; y = y+MAILLE*zoom_y) {
                int l = int(y/MAILLE/zoom_y-l_min);
                if ((x+bordure_x <= x_precedent) && (x+bordure_x >= mouseX-MAILLE*zoom_x)
                 && (y+bordure_y <= y_precedent) && (y+bordure_y >= mouseY-MAILLE*zoom_y))
                {
                    mouseButton_test(c,l+niveau*L_MAX);
                }
            }
        }
        one_shot = true;
    }
}
//************************************ mouseButtonTest() *************************************
void mouseButton_test(int _c, int _l) {
    if (mouseButton == LEFT) {                                                                                                                    //  on sélectionne des pavés
        paveCL = tco.paves[_c][_l];
        pave_selectionne = paveCL;
        if (paveCL != null) {
            tco.paves[_c][_l].selectionne = true;
        }
    } else {
        if (mouseButton == RIGHT) {                                                                                                               //  on déselectionne les pavés
        paveCL = tco.paves[_c][_l];
        pave_selectionne = paveCL;
            if (paveCL != null) {
                tco.paves[_c][_l].selectionne = false;
            }
        }      
    }
}
//*********************************** mouseReleased() **************************************
void mouseReleased() {
    //---------------------------------------------------------------- calcul de l'offset -------------------------------------------------------------------------
    if (deplacement) {                                                                                                                            //  deplacement d'un ou de plusieurs pavés
        int count = 0;
        for(Pave pave : paves_volants) {                                                                                                          //  pour tous les pavés volants
            count++;
            if (count == 1) {                                                                                                                     //  l'offset du premier pavé donne l'offset de tous les pavés                        
                c_mouse     = int((mouseX-bordure_x)/MAILLE/zoom_x-c_min);
                l_mouse     = int((mouseY-bordure_y)/MAILLE/zoom_y-l_min+niveau*L_MAX);
                int c_reference = pave.c;
                int l_reference = pave.l;
                xOffset     = c_mouse-c_reference;
                yOffset     = l_mouse-l_reference;
                if (c_mouse == c_reference && l_mouse == l_reference) {                                                                           //  si on est revenu au depart : offset = 0
                    xOffset = 0;
                    yOffset = 0;
                }
                if (pave.type == 11 && deplacement) {                                                                                             //---------------------  cas particulier des voies de pont --------------------------
                    boolean emplacement_autorise = false;                                                                                         //  on doit trouver le numero d'ordre de la voie sur le pont quand on pose le pavé
                    for (int i = 0; i < 160; i = i+2) { 
                        if (c_mouse == Pont[i] && l_mouse == Pont[i+1]) {                                                                         //  les pavés de voie pont doivent etre exclusivement sur les emplacements des etiquettes...
                            emplacement_autorise = true;                                                                                          //  ... emplacements qui sont memorises dans la matrice de pont
                            etiquettes_pont      = true;
                            pave.ordre           = i/2;                                                                                           //  l'odre correspond au numéro d'étiquette
                            if (i == 0) {                                                                                                         //  ce systeme ne marche pas pour le cas particulier du zero
                                pave.ordre = pavePont.ordre;                                                                                      //  on doit donc aller chercher le nombre de voies max
                            }
                            break;
                        }
                    }
                    if (!emplacement_autorise) {                                                                                                  //  la voie n'est pas sur les bons emplacements : on efface et on recommence
                        deplacement               = false;                                                                                        //  le déplacement est annulé, ce qui servira par le suite (traitement pose de pavé)
                        count                     = 0;
                        xOffset                   = 0;
                        yOffset                   = 0;
                        tco.paves[pave.c][pave.l] = null;
                        tous_paves.remove(tous_paves.size()-1);                                                                                   //  on efface le dernier pavé qui est celui de la voie de pont qu'on est en train de traiter
                        cursor(ARROW);
                    }
                }
            }
        }
        if (xOffset != 0 || yOffset != 0) {
            //-------------------------------------------------------------  sauvegarde avant déplacement --------------------------------------------------------------
            if (sauve) {
                sauve_TCO();
            }
            //------------------------------------------------------------- cas d'écrasement de pavés  ------------------------------------------------
            boolean tout_le_niveau = false;
            if (paves_volants.size() == tous_paves0.size() && paves_volants.get(0).l < L_MAX) {                                                   //  test pour savoir si c'est tout le niveau 0 qui a été sélectionné
                tout_le_niveau = true;
            }
            if (paves_volants.size() == tous_paves1.size() && paves_volants.get(0).l > L_MAX) {                                                   //  test pour savoir si c'est tout le niveau 1 qui a été sélectionné
                tout_le_niveau = true;
            }
            if (!tout_le_niveau) {                                                                                                                //  si on n'a pas sélectionné tout un niveau, on peut écraser d'autres pavés
                boolean trouve         = false;
                for (Pave pave1 : tous_paves) {                                                                                                   //  pour tous les pavés ...
                    if (!pave1.selectionne) {                                                                                                     //  ... non sélectionnés ...
                        for (Pave pave2 : paves_volants) {                                                                                        //  ... on cherche si ce pavé appartient aux pavés volants ...
                            if (pave2.c+xOffset == pave1.c && pave2.l+yOffset == pave1.l) {                                                       //  ... c'est le cas s'ils ont même c et même l
                                showMessageDialog(null, "L'un des pavés posés aurait écrasé un pavé existant"
                                              +char(10)+"Donc, retour à la situation précédente"
                                              +char(10)+" "
                                              +char(10)+"Conseil : si vous voulez vraiment placer les pavés à cet endroit, "                                  
                                              +char(10)+"déplacez d'abord le pavé qui aurait été écrasé"                                  
                                              +char(10)+" "
                                              +char(10)+"Autre solution : déplacer la totalité du niveau et pas seulement une partie"                                  
                                                      , "Attention", ERROR_MESSAGE);
                                trouve = true;
                                break;
                            }
                        }
                    }
                }
                if (trouve) {                                                                                                                     //  on a trouvé un pavé écrasé
                    paves_volants.clear();                                                                                                        //  retour à l'ancienne situation
                    mode_selection = false;
                    for (Pave pave1 : tous_paves) {
                        pave1.selectionne = false;
                    }
                    one_shot       = true;
                }
            }
            //----------------------------------------------------------- dessin du pavé au nouvel emplacement --------------------------------------------------
            for (Pave pave : paves_volants) {                                                                                                     //  pour tous les pavés volants
                if (pave.type == 12) {                                                                                                            //  cas du pont : on met a jour la matrice de pont
                    //---------------------------- Pont tournant ----------------------------------
                    if (pavePont != null) {
                        int total_voies = pavePont.ordre;         //  24 -> 24  32 -> 32  40 ->  40  48  ->  48
                        int valeur1     = total_voies/4;          //  24 -> 6   32 -> 8   40 ->  10  48  ->  12
                        int valeur2     = total_voies/8;          //  24 -> 3   32 -> 4   40 ->  5   48  ->  6
                        int valeur3     = total_voies+1-valeur2;  //  24 -> 22  32 -> 29  40 ->  36  48  ->  43
                        int valeur4     = valeur1+valeur2;        //  24 -> 9   32 -> 12  40 ->  15  48  ->  18
                        int valeur5     = valeur1+valeur4+1;      //  24 -> 16  32 -> 21  40 ->  26  48  ->  31
                        
                        for (int i = 0; i < valeur1; i++) {
                            Pont[2*((valeur3+i) % total_voies)]   = pave.c+valeur2;
                            Pont[2*((valeur3+i) % total_voies)+1] = pave.l+valeur2-1-i;
                            if (i == (valeur2-1)) {
                                Pont[0]                           = pave.c+valeur2;
                                Pont[1]                           = pave.l;
                            }
                            Pont[2*(valeur4-i)]                   = pave.c-valeur2+i;
                            Pont[2*(valeur4-i)+1]                 = pave.l-valeur2;
                            Pont[2*(valeur4+1+i)]                 = pave.c-valeur2;
                            Pont[2*(valeur4+1+i)+1]               = pave.l-valeur2+1+i;
                            Pont[2*(valeur5+i)]                   = pave.c-valeur2+1+i;
                            Pont[2*(valeur5+i)+1]                 = pave.l+valeur2;
                        }
                        for (int i = 0; i < 160; i = i+2) {
                            Pont[i]   = Pont[i]  +xOffset;
                            Pont[i+1] = Pont[i+1]+yOffset;
                        }
                        pavePont = pave;
                        tco.paves[pave.c+xOffset][pave.l+yOffset] = pave;                                                                         //  le pavé est situé au futur emplacement sur le TCO
                        pave.c                                    = pave.c+xOffset;                                                               //  mise à jour des coordonnées c/l du pavé
                        pave.l                                    = pave.l+yOffset;
                        pave.selectionne                          = false;                                                                        //  le nouveau pavé n'est pas sélectionné
                        tous_paves.set(pave.ordre_tous_paves, pave);                                                                              //  dans "tous_pavés", on substitue le nouveau pavé à l'ancien, au même emplacement
                        tco.paves[pave.c-xOffset][pave.l-yOffset] = null;                                                                         //  l'ancien emplacement du pavé sur le TCO est effacé
                        etiquettes_pont = true;
                        cursor(ARROW);
                        mode_selection = false;
                        one_shot = true;
                        cursor(ARROW);
                    } else {
                        if (!pont_tournant_pose && pave.type == 12 && mouseButton == LEFT) {
                            pont_tournant_pose = true;                        
                            pave.selectionne   = true;
                            String max_track_input = showInputDialog("Entrez le nombre de voies maxi du pont tournant :"+
                                                            char(10)+"un multiple de 8 (de 8 à 80)");
                            if (max_track_input == null || max_track_input.equals("") || max_track_input.equals(" ")) {             
                                showMessageDialog(null, "Vous n'avez rien rentre",
                                                        "Attention", ERROR_MESSAGE);
                                pont_tournant_pose = false;
                            } else {                                                                                                              //  entree valide
                                for (int i = 0; i < 160; i++) {                                                                                   //  mise a zero de la matrice de pont
                                    Pont[i] = 0;
                                }                            
                                int total_voies = int(max_track_input);                                                                           //  24 -> 24  32 -> 32  40 ->  40  48  ->  48
                                if (!(total_voies % 8 == 0 && total_voies > 7 && total_voies < 81)) {
                                    showMessageDialog(null, "Le nombre rentré ne peut être qu'un multiple de 8 (de 8 à 80)",
                                                            "Attention", ERROR_MESSAGE);                                
                                    pont_tournant_pose = false;
                                    etiquettes_pont    = false;
                                    pavePont           = null;
                                } else {                                                                                                          //  on remplit la matrice de pont avec les coordonnees des etiquettes...
                                                                                                                                                  //  ...ce sont les seuls endroits possibles pour poser une voie de plque
                                    int valeur1     = total_voies/4;                                                                              //  24 -> 6   32 -> 8   40 ->  10  48  ->  12
                                    int valeur2     = total_voies/8;                                                                              //  24 -> 3   32 -> 4   40 ->  5   48  ->  6
                                    int valeur3     = total_voies+1-valeur2;                                                                      //  24 -> 22  32 -> 29  40 ->  36  48  ->  43
                                    int valeur4     = valeur1+valeur2;                                                                            //  24 -> 9   32 -> 12  40 ->  15  48  ->  18
                                    int valeur5     = valeur1+valeur4+1;                                                                          //  24 -> 16  32 -> 21  40 ->  26  48  ->  31
                                    
                                    for (int i = 0; i < valeur1; i++) {
                                        Pont[2*((valeur3+i) % total_voies)]   = pave.c+valeur2;
                                        Pont[2*((valeur3+i) % total_voies)+1] = pave.l+valeur2-1-i;
                                        if (i == (valeur2-1)) {
                                            Pont[0]                           = pave.c+valeur2;
                                            Pont[1]                           = pave.l;
                                        }
                                        Pont[2*(valeur4-i)]                   = pave.c-valeur2+i;
                                        Pont[2*(valeur4-i)+1]                 = pave.l-valeur2;
                                        Pont[2*(valeur4+1+i)]                 = pave.c-valeur2;
                                        Pont[2*(valeur4+1+i)+1]               = pave.l-valeur2+1+i;
                                        Pont[2*(valeur5+i)]                   = pave.c-valeur2+1+i;
                                        Pont[2*(valeur5+i)+1]                 = pave.l+valeur2;
                                    }
                                    for (int i = 0; i < 160; i = i+2) {
                                        Pont[i]   = Pont[i]  +xOffset;
                                        Pont[i+1] = Pont[i+1]+yOffset;
                                    }
                                    pavePont = pave;
                                    tco.paves[pave.c+xOffset][pave.l+yOffset] = pave;                                                             //  le pavé est situé au futur emplacement sur le TCO
                                    pave.c                                    = pave.c+xOffset;                                                   //  mise à jour des coordonnées c/l du pavé
                                    pave.l                                    = pave.l+yOffset;
                                    pave.selectionne                          = false;                                                            //  le nouveau pavé n'est pas sélectionné
                                    tous_paves.set(pave.ordre_tous_paves, pave);                                                                  //  dans "tous_pavés", on substitue le nouveau pavé à l'ancien, au même emplacement
                                    tco.paves[pave.c-xOffset][pave.l-yOffset] = null;                                                             //  l'ancien emplacement du pavé sur le TCO est effacé
                                    pave.ordre      = int(max_track_input);
                                    etiquettes_pont = true;
                                    cursor(ARROW);
                                }
                            }                        
                            mode_selection = false;
                            one_shot = true;
                            cursor(ARROW);
                        }
                    }
                } else {
                    if (!(pave.type == 11 && !deplacement)) {                                                                                                
                        tco.paves[pave.c+xOffset][pave.l+yOffset] = pave;                                                                         //  le pavé est situé au futur emplacement sur le TCO
                        pave.c = pave.c+xOffset;                                                                                                  //  mise à jour des coordonnées c/l du pavé
                        pave.l = pave.l+yOffset;
                        pave.selectionne = false;                                                                                                 //  le nouveau pavé n'est pas sélectionné
                        tous_paves.set(pave.ordre_tous_paves, pave);                                                                              //  dans "tous_pavés", on substitue le nouveau pavé à l'ancien, au même emplacement
                        tco.paves[pave.c-xOffset][pave.l-yOffset] = null;                                                                         //  l'ancien emplacement du pavé sur le TCO est effacé
                        cursor(ARROW);
                    }
                }
            }
        }
        deplacement              = false;
        voie_pont_tournant_posee = false;
        mode_selection           = false;
        for (Pave pave : paves_volants) {
            pave.selectionne = false;
        }
        paves_volants.clear();
        one_shot = true;
    } else {                                                                                                                                      //  on n'est pas en train de déplacer un ou plusieurs pavés      
        int x_mouse = mouseX;
        int y_mouse = mouseY;
        c_mouse = int((x_mouse-bordure_x)/MAILLE/zoom_x-c_min);
        l_mouse = int((y_mouse-bordure_y)/MAILLE/zoom_y-l_min+niveau*L_MAX);
        pave = tco.paves[c_info_pave][l_info_pave];                                                                                               //  les infos longueur/hauteur seront rangees dans le pavé d'information defini avant
                                                                                                                                                  //  -> c_mouse, l_mouse sont les coordonnes du pavé en cours de traitement
        if (pave != null) {
            if (mode_flexible) {
                //----------------------------------------------------------- FlexibleSgauche ou droit -------------------------------
                if (mouseButton == RIGHT) {                                                                                                       //  il s'agit ici de pouvoir ajuster la deformation du pavé flexible...
                    switch (pave.orientation) {                                                                                                   //  ... quelque soit l'orientation du pavé
                        case 1:
                            longueur_avant    =  int(c_mouse-c_info_pave-1);
                            hauteur_avant     =  int(l_mouse-l_info_pave);
                            pave.hauteur_voie = -abs(hauteur_avant);
                            break;
                        case 2:
                            longueur_avant    =  int(c_mouse-c_info_pave);
                            hauteur_avant     =  int(l_mouse-l_info_pave);
                            pave.hauteur_voie =  abs(hauteur_avant);
                            break;
                        case 3:
                            longueur_avant    =  int(l_mouse-l_info_pave-1);
                            hauteur_avant     = -int(c_mouse-c_info_pave);
                            pave.hauteur_voie = -abs(hauteur_avant);
                            break;
                        case 4:
                            longueur_avant    =  int(l_mouse-l_info_pave);
                            hauteur_avant     = -int(c_mouse-c_info_pave);
                            pave.hauteur_voie =  abs(hauteur_avant);
                            break;
                        case 5:
                            longueur_avant    = -int(c_mouse-c_info_pave+1);
                            hauteur_avant     = -int(l_mouse-l_info_pave);
                            pave.hauteur_voie = -abs(hauteur_avant);
                            break;
                        case 6:
                            longueur_avant    = -int(c_mouse-c_info_pave);
                            hauteur_avant     = -int(l_mouse-l_info_pave);
                            pave.hauteur_voie =  abs(hauteur_avant);
                            break;
                        case 7:
                            longueur_avant    = -int(l_mouse-l_info_pave+1);
                            hauteur_avant     =  int(c_mouse-c_info_pave);
                            pave.hauteur_voie = -abs(hauteur_avant);
                            break;
                        case 8:
                            longueur_avant    = -int(l_mouse-l_info_pave);
                            hauteur_avant     =  int(c_mouse-c_info_pave);
                            pave.hauteur_voie = -abs(hauteur_avant);
                            break;
                    }
                    pave.longueur_voie = max(1, longueur_avant);
                    one_shot = true;
                }
            }
            //------------------------------- Voie de pont -------------------------------------------
            if (voie_pont_tournant_posee) {
                if (mouseButton == RIGHT) {                                                                                                       //  quand on a choisi le pavé de destination (clic droit) on définit :
                    pave.longueur_voie = int(c_mouse-pavePont.c);                                                                                 //  1°) la longueur de la nouvelle voie par rapport au centre du pont
                    pave.hauteur_voie  = int(l_mouse-pavePont.l);                                                                                 //  2°) la hauteur  de la nouvelle voie par rapport au centre du pont
                    mode_selection           = false;                                                                                             //  ... on passe en mode non sélectionné
                    mode_flexible            = false;
                    voie_pont_tournant_posee = false;
                    unselect_all();
                    one_shot = true;
                    cursor(ARROW);
                }
            }
        }
    }
}

//************************************ mouseWheel() *************************************
void mouseWheel(MouseEvent event) {
    zoom_change = event.getCount();
    key_zoom();
}

//************************************ mouseClicked() *************************************
void mouseClicked() {
    if (mouseX < width-CURSEUR-2 && (mouseY >= height-150 && mouseY < height-2-CURSEUR)) {
        switch (position_bouton) {
            //--------------------------------------- Selection -------------------------------------------
            case 0:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide selection.png");
                    largeur_texte = 552;
                    hauteur_texte = 289;
                } else {            
                    if (!mode_selection) {                                                                                                        //  si on n'est pas en mode sélection ...
                        mode_selection           = true;                                                                                          //  ... on passe en mode sélection
                        unselect_all();
                        cursor(CROSS);
                    } else {                                                                                                                      // si on est en mode sélection ...
                        mode_selection           = false;                                                                                         //  ... on passe en mode non sélectionné
                        mode_flexible            = false;
                        voie_pont_tournant_posee = false;
                        unselect_all();
                        one_shot = true;
                        cursor(ARROW);
                    }
                }
                break;
            //--------------------------------------- Deplace -------------------------------------------
            case 1:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide deplace.png");
                    largeur_texte = 552;
                    hauteur_texte = 242;
                } else {
                    if (mode_selection) {
                        paves_volants.clear();
                        ArrayList<String> noms_zones = new ArrayList<String>();                                                                   //  liste de toutes les zones sélectionnées
                        int niveau_selectionne = -1;
                        for (Pave pave : tous_paves) {
                            if (pave.selectionne) {
                                paves_volants.add(pave);
                                if (!noms_zones.contains(pave.ID_zone)) {                                                                         //  pour n'avoir chaque nom de zone qu'une seule fois
                                    noms_zones.add(pave.ID_zone);
                                    if (pave.l > L_MAX) {
                                        niveau_selectionne = 1;
                                    } else {
                                        niveau_selectionne = 0;
                                    }
                                }
                            }
                        }
                        boolean trouve = false;
                        for (Pave pave : tous_paves) {
                            if (noms_zones.contains(pave.ID_zone) && !pave.selectionne && !pave.ID_zone.equals("_")) {
                                if ((niveau_selectionne == 0 && pave.l < L_MAX) || (niveau_selectionne == 1 && pave.l > L_MAX)) {
                                    trouve = true;
                                    showMessageDialog(null, "Dans la zone "+pave.ID_zone+" certains pavés appartenant à la zone n'ont pas été sélectionnés"+
                                                   char(10)+"Peaufinez votre sélection",
                                                            "Attention", ERROR_MESSAGE);
                                    trouve = true;
                                }
                            }
                        }
                        if (!trouve) {
                            deplacement = true;
                        }
                    }
                }
                break;
            //--------------------------------------- Gomme -----------------------------------------
            case 2:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide gomme.png");
                    largeur_texte = 552;
                    hauteur_texte = 306;
                } else {
                    if (mode_selection) {
                        nettoyage = true;
                        sauve     = true;
                        one_shot  = true;
                    }
                }
                break;
            //--------------------------------------- Tourne + -----------------------------------------
            case 3:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide tourne.png");
                    largeur_texte = 552;
                    hauteur_texte = 162;
                } else {
                    if (mode_selection) {
                        int total = 0;
                        for (int c1 = 0; c1 < C_MAX; c1++) {
                            for (int l1 = l_start; l1 < l_stop; l1++) {
                                paveCL = tco.paves[c1][l1];
                                if (paveCL != null && paveCL.selectionne) {
                                    pave_selectionne = paveCL;
                                    total++;
                                }
                            }
                        }
                        if (total != 0) {
                            if (total == 1) {
                                if (pave_selectionne.type != 12) {
                                    pave_selectionne.orientation = (pave_selectionne.orientation+7+1)%8+1;                                       //  memorisation de l'orientation du pavé
                                } else {
                                    theta = theta+0.0130899F;
                                }
                                one_shot = true;
                            } else {
                                showMessageDialog(null, "On ne peut tourner qu'un seul pavé a la fois",
                                                        "Attention", ERROR_MESSAGE);
                            }
                        } else {
                            showMessageDialog(null, "Vous n'avez pas sélectionné de pavés",
                                                        "Attention", ERROR_MESSAGE);
                        }
                    }
                }
                break;
            //--------------------------------------- Tourne - -----------------------------------------
            case 4:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide tourne.png");
                    largeur_texte = 552;
                    hauteur_texte = 162;
                } else {
                    if (mode_selection) {
                        int total = 0;
                        for (int c1 = 0; c1 < C_MAX; c1++) {
                            for (int l1 = l_start; l1 < l_stop; l1++) {
                                paveCL = tco.paves[c1][l1];
                                if (paveCL != null && paveCL.selectionne) {
                                    pave_selectionne = paveCL;
                                    total++;
                                }
                            }
                        }
                        if (total != 0) {
                            if (total == 1) {
                                if (pave_selectionne.type != 12) {
                                    pave_selectionne.orientation = (pave_selectionne.orientation+7-1)%8+1;                                        //  memorisation de l'orientation du pavé
                                } else {
                                    theta = theta-0.0130899F;
                                }
                                one_shot = true;
                            } else {
                                showMessageDialog(null, "On ne peut tourner qu'un seul pavé a la fois",
                                                        "Attention", ERROR_MESSAGE);
                            }
                        } else {
                            showMessageDialog(null, "Vous n'avez pas sélectionne de pavés",
                                                    "Attention", ERROR_MESSAGE);
                        }
                    }
                }
                break;
            //--------------------------------------- Zoom + -----------------------------------------
            case 5:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide zoom.png");
                    largeur_texte = 552;
                    hauteur_texte = 258;
                } else {
                    zoom_change = 1;
                    key_zoom();
                }
                break;
            //--------------------------------------- Zoom - -----------------------------------------
            case 6:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide zoom.png");
                    largeur_texte = 552;
                    hauteur_texte = 258;
                } else {
                    zoom_change = -1;
                    key_zoom();
                }
                break;
            //--------------------------------------- Palette -----------------------------------------
            case 7:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide palette.png");
                    largeur_texte = 552;
                    hauteur_texte = 49;
                } else {
                    affiche_palette = !affiche_palette;
                    palette.in_palette = false;
                    one_shot = true;
                }
                break;
            //--------------------------------------- Niveau -----------------------------------------
            case 8:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide niveau.png");
                    largeur_texte = 552;
                    hauteur_texte = 162;
                } else {
                    if (!mode_selection) {
                        niveau = 1-niveau;
                        one_shot = true;
                    }
                }
                break;
            //--------------------------------------- Grille -------------------------------------------
            case 9:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide grille.png");
                    largeur_texte = 552;
                    hauteur_texte = 98;
                } else {
                    affiche_grille = !affiche_grille;
                    one_shot = true;
                    if (affiche_grille) {
                        etiquettes_pont = true;
                    } else {
                        etiquettes_pont = false;
                    }
                }
                break;
            //--------------------------------------- Fichier -----------------------------------------
            case 10:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide fichier.png");
                    largeur_texte = 552;
                    hauteur_texte = 322;
                } else {
                    sauve = false;
                    sauve_TCO();
                    fill(FOND);
                    rect(0, 0, width, height);
                    selectInput("Selectionnez un fichier pour charger le réseau : ", "fileSelected");
                }
                break;
            //--------------------------------------- Sauve -----------------------------------------
            case 11:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide sauve.png");
                    largeur_texte = 552;
                    hauteur_texte = 226;
                } else {
                    sauve = true;
                    sauve_TCO();
                    sauve = false;
                }
                break;
            //--------------------------------------- Zone -----------------------------------------
            case 12:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide zone.png");
                    largeur_texte = 552;
                    hauteur_texte = 226;
                } else {
                    if (mode_selection) {
                        Zone zone1 = new Zone();
                        zone_traitee = zone1;
                        zone1.ID_zone();
                        cursor(ARROW);
                    }
                }
                break;
            //--------------------------------------- Points -----------------------------------------
            case 13:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide points.png");
                    largeur_texte = 552;
                    hauteur_texte = 146;
                } else {
                    affiche_points = !affiche_points;
                    one_shot = true;
                }
               break;
            //--------------------------------------- Analyse -----------------------------------------
            case 14:
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide analyse.png");
                    largeur_texte = 552;
                    hauteur_texte = 178;
                } else {
                    analyse();
                }
                break;
            //--------------------------------------- Aide -----------------------------------------
            case 15:
                aide = !aide;
                if (aide) {
                    texte_aide    = loadImage("data/Aide/Aide aide.png");
                    largeur_texte = 552;
                    hauteur_texte = 112;
                }
                break;
            default:
        }
    }
    if (palette.in_palette) {        
        if (aide) {
            switch (position_pave) {
                case 101:            //  colonne 1, ligne 1
                case 201:            //  colonne 2, ligne 1
                    texte_aide    = loadImage("data/Aide/Aide palette gros pave.png");
                    largeur_texte = 552;
                    hauteur_texte = 49;
                    break;
                case 102:            //  colonne 1, ligne 2
                    texte_aide    = loadImage("data/Aide/Aide palette pave droit.png");
                    largeur_texte = 552;
                    hauteur_texte = 403;                    
                    break;
                case 202:            //  colonne 2, ligne 2
                    texte_aide    = loadImage("data/Aide/Aide palette pave butoir.png");
                    largeur_texte = 552;
                    hauteur_texte = 48;                    
                    break;
                case 103:            //  colonne 1, ligne 3
                    texte_aide    = loadImage("data/Aide/Aide palette pave arc45.png");
                    largeur_texte = 552;
                    hauteur_texte = 48;                    
                    break;
                case 203:            //  colonne 2, ligne 3
                    texte_aide    = loadImage("data/Aide/Aide palette pave arc90.png");
                    largeur_texte = 552;
                    hauteur_texte = 544;                    
                    break;
                     case 104:        //  colonne 1, ligne 4
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible S droit.png");
                    largeur_texte = 552;
                    hauteur_texte = 498;                    
                    break;
                case 204:            //  colonne 2, ligne 4
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible S gauche.png");
                    largeur_texte = 552;
                    hauteur_texte = 498;                    
                    break;
                case 105:            //  colonne 1, ligne 5
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible C droit.png");
                    largeur_texte = 552;
                    hauteur_texte = 269;                    
                    break;
                case 205:            //  colonne 2, ligne 5
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible C gauche.png");
                    largeur_texte = 552;
                    hauteur_texte = 269;                    
                    break;
                case 106:            //  colonne 1, ligne 6
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible J droit.png");
                    largeur_texte = 552;
                    hauteur_texte = 256;                    
                    break;
                case 206:            //  colonne 2, ligne 6
                    texte_aide    = loadImage("data/Aide/Aide palette pave flexible J gauche.png");
                    largeur_texte = 552;
                    hauteur_texte = 256;                    
                    break;
                case 107:            //  colonne 1, ligne 7
                    texte_aide    = loadImage("data/Aide/Aide palette pave voie de pont.png");
                    largeur_texte = 1054;
                    hauteur_texte = 417;                    
                    break;
                case 207:            //  colonne 2, ligne 7
                    texte_aide    = loadImage("data/Aide/Aide palette pave pont tournant.png");
                    largeur_texte = 552;
                    hauteur_texte = 512;                    
                    break;
                 case 108:           //  colonne 1, ligne 8
                    texte_aide    = loadImage("data/Aide/Aide palette pave traversee 45.png");
                    largeur_texte = 552;
                    hauteur_texte = 82;                    
                    break;
                case 208:            //  colonne 2, ligne 8
                    texte_aide    = loadImage("data/Aide/Aide palette pave traversee 90.png");
                    largeur_texte = 552;
                    hauteur_texte = 82;                    
                    break;
                case 109:            //  colonne 1, ligne 9
                    texte_aide    = loadImage("data/Aide/Aide palette pave branchement droit.png");
                    largeur_texte = 552;
                    hauteur_texte = 81;                    
                    break;
                case 209:            //  colonne 2, ligne 9
                    texte_aide    = loadImage("data/Aide/Aide palette pave branchement gauche.png");
                    largeur_texte = 552;
                    hauteur_texte = 50;                    
                    break;
                case 110:            //  colonne 1, ligne 10
                    texte_aide    = loadImage("data/Aide/Aide palette pave TJS.png");
                    largeur_texte = 552;
                    hauteur_texte = 50;                    
                    break;
                case 210:            //  colonne 2, ligne 10
                    texte_aide    = loadImage("data/Aide/Aide palette pave TJD.png");
                    largeur_texte = 552;
                    hauteur_texte = 50;                    
                    break;
                case 111:            //  colonne 1, ligne 11
                    texte_aide    = loadImage("data/Aide/Aide palette pave branchement triple.png");
                    largeur_texte = 552;
                    hauteur_texte = 81;                    
                    break;
                case 211:            //  colonne 2, ligne 11
                    texte_aide    = loadImage("data/Aide/Aide palette pave branchement symetrique.png");
                    largeur_texte = 552;
                    hauteur_texte = 399;                    
                    break;
          default:
            }
        }
    }
    if (mouseX > width-CURSEUR || mouseY > height-CURSEUR) {
        texte_aide    = loadImage("data/Aide/Aide ascenseur.png");
        largeur_texte = 552;
        hauteur_texte = 66;                    
    }
}
