//******************************* TCO() ******************************
class TCO {
    Pave paves[][]           = new Pave[C_MAX][2*L_MAX];
    boolean  presence_pave_occupe = false;
    //------------------------------------ dessine_tco() -------------------------------------------
    void dessine_tco() {
        nettoyage_effectue = false;
        numero_de_zone     = "";
        pont_compte_voies  = 0;
        int reponse        = -1;                                                                                                                  //  il faut que ce ne soit ni 0, ni 1
        int compteur_paves = -1;
        for (Pave pave : tous_paves) {
            compteur_paves++;
            pave.ordre_tous_paves = compteur_paves;
            if (pave.type != 12) {                                                                                                                //  pas pont tournant...
                if (pave.type != 11) {                                                                                                            //  ... pas voie du pont tournant...
                    dessine_pave_du_tco(pave);                                                                                                    //  ... on dessine donc un pavé normal
                } else {                                                                                                                          //  c'est une voie de pont tournant
                    if (!pont_tournant_pose && deplacement) {
                        showMessageDialog(null, "Avant de poser les voies du pont tournant, vous devez :"
                                      +char(10)+"1°) avoir posé un pont tournant sur le TCO"
                                      +char(10)+"2°) avoir choisi le nombre maximal de voies pour ce pont"
                                              , "Attention", ERROR_MESSAGE);
                        deplacement = false;
                        nettoyage   = true;
                    } else {
                        pont_compte_voies++;
                        dessine_pave_du_tco(pave);
                    }                           
                }
            } else {                                                                                                                              //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                c0_pont  = pave.c+0.5F;                                                                                                           //  c, l sont les coordonnes du PAVE du pont tournant (coin supérieur gauche du pavé)
                l0_pont  = pave.l+0.5F;                                                                                                           //  c0, l0 sont les coordonnees du CENTRE du pont tournant
            }
            if (!deplacement) {                                                                                                                   //  on ne peut effacer quelque chose que si on n'est pas en déplacement
                if (pave.selectionne && nettoyage) {
                    if (pave.ID_zone.equals("_")) {                                                                                               //  si le pavé n'a pas d'identifiant de zone, on pourrait l'effacer...                                                                                                              
                        if (pave.type == 12) {                                                                                                    //  ... mais si c'est le pont tournant ...
                            if (pont_compte_voies == 0) {                                                                                         //  ... on doit verifier qu'il n'a pas de voies de pont : pas de voie de pont => on peut l'effacer
                                tous_paves.set(compteur_paves, palette.palettes[0][0]);                                                           //  on marque le pavé dans l'ArrayList pour effacement ultérieur
                                pavePont           = null;
                                etiquettes_pont    = false;
                                pont_tournant_pose = false;
                                deplacement        = false;
                                sauve              = false;
                                nettoyage_effectue = true;
                            } else {                                                                                                              //  ... si elle a des voies, message d'alerte et annulation du nettoyage
                                showMessageDialog(null, "Il est impossible d'effacer le pont tournant seul"+
                                               char(10)+"sans effacer aussi TOUTES les voies du pont",
                                                        "Attention", ERROR_MESSAGE);
                            }
                        } else {                                                                                                                  //  c'est le cas normal (donc hors pont)
                            if (reponse == -1) {                                                                                                  //  on n'a rien choisi. C'est la première fois qu'on pose une question
                                reponse = showConfirmDialog(null,"L'effacement concerne directement les pavés sélectionnés"+ 
                                                        char(10)+"               Voulez-vous les effacer ?"+       
                                               char(10)+char(10)+" OUI : Effacer tous les pavés sélectionnés"+
                                                        char(10)+" NON : Sauver les pavés",
                                                                 "Attention", YES_NO_OPTION);
                                
                            }
                            if (reponse == YES_OPTION) {                                                                                          //---------- YES_OPTION --------------
                                if (!nettoyage_effectue) {
                                    sauve = false;                                                                                                //  avant d'effacer, sauvegarde du TCO
                                    sauve_TCO();
                                }
                                tous_paves.set(compteur_paves, palette.palettes[0][0]);                                                                  //  on marque le pavé dans l'ArrayList pour effacement ultérieur
                                tco.paves[pave.c][pave.l]       = null;                                                                           //  effacement du pavé dans l'Array TCO
                            } else {                                                                                                              //---------- NO_OPTION ---------------
                                showMessageDialog(null, "Rien n'a été fait : les pavés ont été conservés");
                                unselect_all();
                            }
                            nettoyage_effectue = true;                                                                                            //  prépare le nettoyage final
                        }
                    } else {                                                                                                                      //  le pavé a bien un identifiant de zone
                        if (reponse == -1) {                                                                                                      //  on n'a rien choisi. C'est la première fois qu'on pose une question
                            reponse = showConfirmDialog(null,"L'effacement ne concerne que les identifiants de la zone contenant ces pavés"+ 
                                                    char(10)+"                       Voulez-vous les effacer ?"+       
                                           char(10)+char(10)+" OUI : Effacer tous les identifiants de la zone (sans effacer les pavés)"+
                                                    char(10)+" NON : Garder tous les identifiants",
                                                             "Attention", YES_NO_OPTION);
                        }
                        if (reponse == YES_OPTION) {                                                                                              //---------- YES_OPTION --------------
                            if (!nettoyage_effectue) {
                                sauve = false;                                                                                                    //  avant d'effacer, sauvegarde du TCO
                                sauve_TCO();
                            }
                            String paveID_zone = pave.ID_zone;
                            for (int c1 = 0; c1 < C_MAX; c1++) {
                                for (int l1 = 0; l1 < 2*L_MAX; l1++) {
                                    paveCL = paves[c1][l1];
                                    if (paveCL != null && paveCL.ID_zone.equals(paveID_zone)) {                                                   //  on n'efface pas le pavé : on n'efface que l'aspect zone du pavé
                                        paveCL.ID_zone  = "_";
                                        for (int i = 0; i < 2; i++) {
                                            for (int j = 0; j < 4; j++) {
                                                paveCL.connecteur[i][j].z = 0;                                                                    //  effacement des connecteurs de la zone
                                            }
                                        }
                                        paveCL.cible[0]    = false;                                                                               //  effacement des cibles de la zone
                                        paveCL.cible[1]    = false;
                                        paveCL.selectionne = false;                                                                               //  effacement de la sélection des pavés
                                    }
                                }
                            }
                        } else {                                                                                                                  //---------- NO_OPTION ---------------
                            showMessageDialog(null, "Rien n'a été fait : le pavé et les identifiants de zone ont été conservés");
                            unselect_all();
                        }
                        nettoyage_effectue = true;                                                                                                //  prépare le nettoyage final
                    }
                }
            }
            one_shot = true;
        }
        //---------------------------------------- pont tournant ---------------------------------         
                                                                                                                                                  //  on dessine le pont tournant dans un deuxieme temps pour qu'il soit toujours au dessus                                                              
                                                                                                                                                  //  (c'est necessaire parce que la cabine du pont depasse des rails de la fosse)
        if (pavePont != null) {
            if (etiquettes_pont) {
                int total_voies = int(pavePont.ordre);                                                                                            //  24 -> 24    32 -> 32    40 ->  40    48  ->  48
                int valeur1     = total_voies/4;                                                                                                  //  24 ->  6    32 ->  8    40 ->  10    48  ->  12
                int valeur2     = total_voies/8;                                                                                                  //  24 ->  3    32 ->  4    40 ->   5    48  ->   6
                int valeur3     = total_voies+1-valeur2;                                                                                          //  24 -> 22    32 -> 29    40 ->  36    48  ->  43
                int valeur4     = valeur1+valeur2;                                                                                                //  24 ->  9    32 -> 12    40 ->  15    48  ->  18
                int valeur5     = valeur1+valeur4+1;                                                                                              //  24 -> 16    32 -> 21    40 ->  26    48  ->  31
                for (int i = 0; i < valeur1; i++) {
                    dessine_label(0, (valeur3+i) % total_voies, pavePont.c+valeur2, pavePont.l+valeur2-1-i);
                    if (i == (valeur2-1)) {
                        dessine_label(0, total_voies, pavePont.c+valeur2, pavePont.l);                            
                    }
                    dessine_label(0, valeur4-i,   pavePont.c-valeur2+i,   pavePont.l-valeur2);
                    dessine_label(0, valeur4+1+i, pavePont.c-valeur2,     pavePont.l-valeur2+1+i);
                    dessine_label(0, valeur5+i,   pavePont.c-valeur2+1+i, pavePont.l+valeur2);
                }
            }
            dessine_pave_du_tco(pavePont);
        }
        //--------------------------------------- nettoyage -------------------------------------------------
        if (nettoyage_effectue) {                                                                                                                 //---------------- nettoyage final -----------------------
            int taille = tous_paves.size();
            for (int i = taille-1; i >= 0; i--) {
                if (tous_paves.get(i) == palette.palettes[0][0]) {
                    tous_paves.remove(i);                                                                                                         //  effacement des pavés marqués dans l'ArrayList
                }
            }
            tous_paves.trimToSize();
            mode_selection  = false;
            nettoyage       = false;
            cursor(ARROW);
            one_shot  = true;
        }
    }
    //------------------------------------ dessine_feux_tco() -------------------------------------------
    void dessine_feux_tco() {
        int ancien_niveau    = niveau;
        int ancien_bordure_x = bordure_x;
        int ancien_bordure_y = bordure_y;
        for (Pave pave : tous_signaux) {
            if (pave.type != 12) {                                                                                                                //  pas pont tournant...
                bordure_x = int(BORDURE_X+MAILLE*zoom_x/2+.5);
                bordure_y = int(BORDURE_Y+MAILLE*zoom_y/2+.5);
                niveau    = 0;
                dessine_feu_pave_du_tco(pave);
            } else {                                                                                                                              //  on dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                pavePont = pave;
            }
        }
        for (Pave pave : tous_signaux) {
            if (pave.type != 12) {                                                                                                                //  pas pont tournant...
                bordure_x = BORDURE_X;
                bordure_y = BORDURE_Y;
                niveau    = 1;                                                                                                                    //  ...donc un pavé normal
                dessine_feu_pave_du_tco(pave);
            } else {                                                                                                                              //  On dessinera le pont tournant dans un deuxieme temps. On memorise ici ses coordonnées.
                pavePont = pave;
            }
        }
        niveau    = ancien_niveau;
        bordure_x = ancien_bordure_x;
        bordure_y = ancien_bordure_y;
    }    
    //---------------------------- dessine_pave_du_tco() -----------------------------------------
    void dessine_pave_du_tco(Pave _pave) {
        pushMatrix();
            translate(bordure_x+(_pave.c+c_min)*MAILLE*zoom_x, bordure_y+(_pave.l+l_min-niveau*L_MAX)*MAILLE*zoom_y);
            scale(zoom_x, zoom_y);
            _pave.dessine_pave(_pave.c, _pave.l);
        popMatrix();
    }        
    //---------------------------- dessine_feu_pave_du_tco() -----------------------------------------
    void dessine_feu_pave_du_tco(Pave _pave) {
        pushMatrix();
            translate(bordure_x+(_pave.c+c_min)*MAILLE*zoom_x, bordure_y+(_pave.l+l_min-niveau*L_MAX)*MAILLE*zoom_y);
            _pave.dessine_feu_pave(0);
            _pave.dessine_feu_pave(1);
        popMatrix();
    }    
    //----------------------------- deplace_pave() --------------------------------------------------
    void deplace_pave() {
        int c_reference = 0;
        int l_reference = 0;
        if (deplacement) {            
            cursor(MOVE);
            int count = 0;            
            for (Pave pave : paves_volants) {
                count++;
                if (count == 1) {                        
                    c_reference = pave.c;
                    l_reference = pave.l;
                } 
                x_mouse = mouseX+(pave.c-c_reference)*MAILLE*zoom_x-bordure_x;
                y_mouse = mouseY+(pave.l-l_reference)*MAILLE*zoom_y-bordure_y;
                pushMatrix();
                    translate((bordure_x+(x_mouse-MAILLE*zoom_x/2F)+c_min), (bordure_y+(y_mouse-MAILLE*zoom_y/2F)+l_min));
                    scale(zoom_x, zoom_y);
                    pave.dessine_pave(pave.c, pave.l);
                popMatrix();
            }
        }
    }    
    //------------------------------- dessine_grille() ----------------------------------------
    void dessine_grille() {
        if (affiche_grille) {                                                                                                                     //  la grille est dessinee en dernier pour eviter des recouvrements et bien definir les pavés deformables
            noFill();
            for (int c = 0; c < C_MAX; c++) {  
                for (int l = l_start; l < l_stop; l++) {
                    if (affiche_coordonnees) {
                        fill(0);
                        stroke(NOIR);
                        text(str(c),bordure_x+(c+c_min)*MAILLE*zoom_x+MAILLE*zoom_x/2, bordure_y+(l+l_min-niveau*L_MAX)*MAILLE*zoom_y+1*MAILLE*zoom_y/4);
                        text(str(l),bordure_x+(c+c_min)*MAILLE*zoom_x+MAILLE*zoom_x/2, bordure_y+(l+l_min-niveau*L_MAX)*MAILLE*zoom_y+3*MAILLE*zoom_y/4);
                        noFill();
                    }
                    pave = paves[c][l];
                    strokeWeight(0.5F);
                    stroke(NOIR);
                    rect(bordure_x+(c+c_min)*MAILLE*zoom_x, bordure_y+(l+l_min-niveau*L_MAX)*MAILLE*zoom_y, MAILLE*zoom_x, MAILLE*zoom_y);
                }
            }
            for (Pave pave : tous_paves) {
                if (pave.deformable) {
                    strokeWeight(2F);
                    stroke(BLEU);
                } else {
                    strokeWeight(1.1F);
                    stroke(VERT_FLUO);
                }
                rect(bordure_x+(pave.c+c_min)*MAILLE*zoom_x, bordure_y+(pave.l+l_min-niveau*L_MAX)*MAILLE*zoom_y, MAILLE*zoom_x, MAILLE*zoom_y, 5);
            }
            noStroke();
        }
    }
    //------------------------------- dessine_label() ------------------------------------
    void dessine_label(int _type_l, int _label_c, int _c, int _l) {                                                                               // dessine le label dans un pavé
    textSize(3*zoom_x);
        if (_label_c != 0) {
            fill(BLANC);
            stroke(0);
            int c_pave = int(bordure_x+(_c+c_min)*MAILLE*zoom_x);
            int l_pave = int(bordure_y+(_l+l_min)*MAILLE*zoom_y-niveau*L_MAX*MAILLE*zoom_y);

            textAlign(CENTER, CENTER);
            switch (_type_l) {
                case 0:
                    rect(c_pave+MAILLE*zoom_x/4, l_pave+MAILLE*zoom_y/4, MAILLE*zoom_x/2, MAILLE*zoom_y/2);
                    fill(0);
                    text(str(_label_c), c_pave+MAILLE*zoom_x/2, l_pave+MAILLE*zoom_y/2);
                    break;
                case 1:
                    rect(c_pave+MAILLE*zoom_x/8, l_pave+MAILLE*zoom_y/8, 3*MAILLE*zoom_x/4, 3*MAILLE*zoom_y/4);
                    fill(0);
                    text(str(_label_c), c_pave+MAILLE*zoom_x/2, l_pave+MAILLE*zoom_y/2);
                    break;           
            }        
            noStroke();
        }
    }
    //---------------------------------------------------------- mise à jour signaux() ---------------------------------------------------------------------
    void maj_signaux() {
        for (Pave pave_depart : tous_paves) {                                                                                                      //  on calcule tous les suivants de signaux et suivant sur la meme zone
            if (!pave_depart.appareil_de_voie) {                                                                                                   //  on part d'un signal, donc pas d'un appareil de voie (qui n'en a pas)
                                                                                                                                                   //  comme on n'est pas sur un appareil de voie, lames = 0 (=> paveCL.connecteur[x][0])
                for (int cote = 0; cote < 2; cote++) {                                                                                             //  on teste les deux cotes
                    pave_depart.pave_signal_suiv[cote]  = null;
                    pave_depart.cote_signal_suiv[cote]  = -1;
                    pave_depart.coord_signal_suiv[cote] = null;
                    if (pave_depart.cible[cote]) {                                                                                                 //----- on est dans le cas d'un pavé qui a deja une cible
                        //--------------------- signal zone -------------------
                        pave_depart.pave_signal_zone[cote]  = pave_depart;
                        pave_depart.cote_signal_zone[cote]  = cote;
                        pave_depart.coord_signal_zone[cote] = pave_depart.connecteur[cote][0];
                        //--------------------- signal suivant --------------------
                        vitesse_maxi                        = 1000;                                                                                //  on part de 1000 car on cherche un minimum
                        presence_pave_occupe                = false;
                        signal_mitoyen(pave_depart.connecteur[cote][0], pave_depart, cote, pave_depart, cote, true);                               //  on cherche le signal suivant du signal_zone avec "true" parce qu'on part d'une cible
                    } else {                                                                                                                       //----- on est dans le cas d'un pavé qui n'a pas de cible
                        //--------------------- signal zone -------------------
                        signal_mitoyen(pave_depart.connecteur[cote][0], pave_depart, cote, pave_depart, cote, false);                              //  on cherche le signal de la zone avec "false" parce qu'on ne part pas d'une cible
                    }
                }
            } else {
                for (int cote = 0; cote < 2; cote++) {                                                                                             //  pour une position des lames connue, un appareil de voie (quel qu'il soit) n'a que 2 cotes 
                    pave_depart.pave_signal_suiv[cote]  = null;
                    pave_depart.cote_signal_suiv[cote]  = -1;
                    pave_depart.coord_signal_suiv[cote] = null;
                    signal_mitoyen(pave_depart.connecteur[cote][pave_depart.lames], pave_depart, cote, pave_depart, cote, false);                  //  on cherche le signal de la zone avec "false" parce qu'on ne part pas d'une cible
                }                
            }
        }
        for (Pave pave_depart : tous_paves) {                                                                                                      //  on calcule tous les suivants de signaux qu'on n'a pas pu calculer avant
            for (int cote = 0; cote < 2; cote++) {                                                                                                 //  il s'agit du cote du signal depart
                if (pave_depart.pave_signal_suiv[cote] == null) {                                                                                  //  les autres cas sont deja regles
                    Pave pave_signal_zone = pave_depart.pave_signal_zone[cote];                                                                    //  "pave_signal_zone" est le pavé zone du signal depart, du bon cote
                    int  cote_signal_zone = pave_depart.cote_signal_zone[cote];                                                                    //  "cote_signal_zone" est le cote, vu du pavé signal zone (qui peut être different du cote du pavé depart)
                    for (Pave pave_zone : tous_paves) {                                                                                            //  comme tous les paves ont un pavé zone, on peut les balayer
                        for (int cote_zone = 0; cote_zone < 2; cote_zone++) {                                                                      //  cette fois, on prend le cote du pavé zone
                            if (pave_zone == pave_signal_zone && cote_zone == cote_signal_zone) {
                                pave_depart.pave_signal_suiv[cote]  = pave_zone.pave_signal_suiv[cote_zone];
                                pave_depart.cote_signal_suiv[cote]  = pave_zone.cote_signal_suiv[cote_zone];
                                pave_depart.coord_signal_suiv[cote] = pave_zone.coord_signal_suiv[cote_zone];
                                pave_depart.code_signal[cote]       = pave_zone.code_signal[cote_zone];
                            }
                        }
                    }
                }
            }
        }
        //----------------------------------- carre_fin_iti -----------------------------
        /*for (Itineraire iti1 : tous_iti) {
            if (iti1.carre_fin_iti && iti1.numero_train > 0) {                                                                                     // on doit afficher un CARRE manuel si c'est une fin d'itinéraire ET qu'un train est sur cet itinéraire 
                for (Pave pave1 : iti1.zone_fin.paves_composant_zone) {
                    if (pave1.cote_signal_fin_iti != -1) {
                        pave1.code_signal[pave1.cote_signal_fin_iti]       = CARRE;
                        pave1.coord_signal_suiv[pave1.cote_signal_fin_iti] = null;
                        pave1.pave_signal_suiv[pave1.cote_signal_fin_iti]  = null;
                        pave1.cote_signal_suiv[pave1.cote_signal_fin_iti]  = -1;
                    }
                }
            }
        }*/
        for (Pave pave_signal : tous_paves) {
            for (int cote = 0; cote < 2; cote++) {
                Pave pave_signal_suivant = pave_signal.pave_signal_suiv[cote];                                                                     //  on simplifie l'ecriture du pavé signal suivant
                Pave pave_suivant        = pave_signal.pave_suivant[cote];                                                                         //  on simplifie l'écriture du pavé suivant
                if (pave_signal_suivant == null
                || (pave_suivant != null && abs(pave_suivant.numero_train) != abs(pave_signal.numero_train))) {                                    //  si pave_signal_suivant est null, on met CARRE fixe
                    pave_signal.code_signal[cote]    = CARRE;
                    pave_signal.couleur_feu[cote]    = ROUGE;
                    pave_signal.feu_clignotant[cote] = false;
                } else {
                    if (pave_signal.code_signal[cote] != SEMAPHORE && pave_signal.code_signal[cote] != CARRE) {                                    //  quand on est sorti de la boucle, on avait trouve tous les SEMAPHORE et il faut regarder les CARRE manuels
                        int code_signal_suivant  = pave_signal_suivant.code_signal[pave_signal.cote_signal_suiv[cote]];                            //  on simplifie l'ecriture du signal suivant
                        if (code_signal_suivant == CARRE || code_signal_suivant == SEMAPHORE) {                                                    //  on calcule alors les AVERTISSEMENTS
                            pave_signal.code_signal[cote]    = AVERTISSEMENT;
                            pave_signal.couleur_feu[cote]    = JAUNE;
                            pave_signal.feu_clignotant[cote] = false;
                        } else {
                            if (code_signal_suivant == RAPPEL_RALENTISSEMENT) {                                                                    //  si le signal suivant (du bon cote) est un ralentissement 30, on met RR30                        
                                pave_signal.code_signal[cote]    = RALENTISSEMENT;
                                pave_signal.couleur_feu[cote]    = JAUNE;
                                pave_signal.feu_clignotant[cote] = false;
                            }
                            if (code_signal_suivant == RAPPEL_RALENTISSEMENT_CLI) {                                                                //  si le signal suivant (du bon cote) est un ralentissement 60, on met RR60                                                
                                pave_signal.code_signal[cote]    = RALENTISSEMENT_CLI;
                                pave_signal.couleur_feu[cote]    = JAUNE;
                                pave_signal.feu_clignotant[cote] = true;
                            }
                        }
                    }
                }
            }
        }
    }    
    //------------------------------- signal_mitoyen() -------------------------------------------------------------------
    void signal_mitoyen(PVector _connecteur_courant, Pave _pave_courant, int _cote_courant, Pave _pave_depart, int _cote_depart, boolean _true_suivant_false_zone) {
        trouve = false;        
        for (Pave pave_boucle : tous_paves) {
            if (trouve) { break; }                                                                                                                 //  on vient de trouver le signal suivant : on sort de la deuxieme boucle
                if (!(pave_boucle == _pave_courant || pave_boucle == _pave_depart)) {                                                              //  on ne prend pas le meme pave, ni le pavé de depart
                    int lames = pave_boucle.lames;                                                                                                 //  variable locale de la position des lames du pavé teste (pour simplifier l'ectiture)
                    if (_cote_courant == 0) {
                        if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[0][lames]) < 1.1) {                                           //  on trouve un connecteur origine   (= [0])
                            if (pave_boucle.type == 2) {
                                 _pave_courant.butoir[_cote_courant] = true;
                            }
                            connecteur_signal_trouve(pave_boucle, 1, _pave_depart, _cote_depart, _true_suivant_false_zone);                                
                        } else {
                            if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[1][lames]) < 1.1) {                                       //  on trouve un connecteur extremite (= [1])
                                if (pave_boucle.type == 2) {
                                     _pave_courant.butoir[_cote_courant] = true;
                                }
                                connecteur_signal_trouve(pave_boucle, 0, _pave_depart, _cote_depart, _true_suivant_false_zone);
                            }
                        }                            
                    } else {
                        if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[0][lames]) < 1.1) {                                           //  on trouve un connecteur origine   (= [0])
                            if (pave_boucle.type == 2) {
                                _pave_courant.butoir[_cote_courant] = true;
                            }
                            connecteur_signal_trouve(pave_boucle, 1, _pave_depart, _cote_depart, _true_suivant_false_zone);
                        } else {
                            if (PVector.dist(_connecteur_courant, pave_boucle.connecteur[1][lames]) < 1.1) {                                       //  on trouve un connecteur extremite (= [1])
                                if (pave_boucle.type == 2) {
                                     _pave_courant.butoir[_cote_courant] = true;
                                }
                                connecteur_signal_trouve(pave_boucle, 0, _pave_depart, _cote_depart, _true_suivant_false_zone);                                
                            }
                        }
                    }
                }
        }
        if (!trouve) {
            _pave_depart.coord_signal_suiv[_cote_depart] = null;
        }                                                                                                                                          //  on n'a pas trouve de mitoyen ( ex : butoir)
    }
    //---------------------------------------------------------- connecteur_signal_trouve() -----------------------------------------------------------
    void connecteur_signal_trouve(Pave _pave_boucle, int _cote_courant, Pave _pave_depart, int _cote_depart, boolean _true_suivant_false_zone) {
        if (_pave_boucle.occupation && !_pave_boucle.ID_zone.equals(_pave_depart.ID_zone)) {                                                       //  on va compter les paves occupés jusqu'au prochain signal
            presence_pave_occupe = true;                                                                                                           //  s'il y en a au moins 1, on a SEMAPHORE
        }
        int lames = _pave_boucle.lames;                                                                                                            //  pour simplifier l'ecriture                                      
        if (!(lames == 0                                                                                                                           //  si  NON (position directe sur l'appareil de voie
          || (lames == 2 && _pave_boucle.type == 17)                                                                                               //          (position directe sur TJS (l'autre positions) 
          || (lames == 2 && _pave_boucle.type == 18))) {                                                                                           //          (position directe sur TJD (l'autre positions) 
            vitesse_maxi = min(vitesse_maxi, _pave_boucle.vitesse_deviee);                                                                         //  alors    on garde la vitesse mini en position deviee
        }
        trouve = true;                                                                                                                             //  on a trouve un connecteur. Mais ce n'est pas fini...
        if (_pave_boucle.cible[_cote_courant]) {                                                                                                   //  si le cote_courant a une cible, c'est la bonne
            if (_true_suivant_false_zone) {                                                                                                        //-------- si on partait d'une cible, on a trouve le signal suivant
                _pave_depart.pave_signal_suiv[_cote_depart]  = _pave_boucle;                                                                       //  on recupere les coordonnées du pavé suivant
                _pave_depart.cote_signal_suiv[_cote_depart]  = _cote_courant;                                                                      //  on recupere le bon cote du signal suivant
                _pave_depart.coord_signal_suiv[_cote_depart] = _pave_boucle.connecteur[_cote_courant][lames];                                      //  on a trouve les coordonnes du signal suivant un signal (sert pour Avertissement et Rappel Ralentissement)
                _pave_depart.feu_si_devie[_cote_depart]      = vitesse_maxi;                                                                       //  on recupere la vitesse maxi de voie deviee
                switch (vitesse_maxi) {                                                                                                            //  on n'est ni CARRE, ni SEMAPHORE
                    case 1000:
                        _pave_depart.code_signal[_cote_depart]    = VOIE_LIBRE;
                        _pave_depart.couleur_feu[_cote_depart]    = VERT;
                        _pave_depart.feu_clignotant[_cote_depart] = false;
                        break;
                    case 30:
                        _pave_depart.code_signal[_cote_depart]    = RAPPEL_RALENTISSEMENT;
                        _pave_depart.couleur_feu[_cote_depart]    = JAUNE;
                        _pave_depart.feu_clignotant[_cote_depart] = false;
                        break;
                    case 60:
                        _pave_depart.code_signal[_cote_depart]    = RAPPEL_RALENTISSEMENT_CLI;
                        _pave_depart.couleur_feu[_cote_depart]    = JAUNE;
                        _pave_depart.feu_clignotant[_cote_depart] = true;
                        break;
                    case 120:  //  à decrire (c'est aussi lie à des panneaux fixes)
                        break;
                }
                if (presence_pave_occupe) {                                                                                                        //--- si on a trouve un pavé occupe dans les paves suivants, on met à SEMAPHORE (qui effacera ce qu'il y avait si besoin)
                    _pave_depart.code_signal[_cote_depart]    = SEMAPHORE;
                    _pave_depart.couleur_feu[_cote_depart]    = ROUGE;
                    _pave_depart.feu_clignotant[_cote_depart] = false;
                }
            } else {                                                                                                                               //-------- si on ne partait pas d'une cible, on a trouve le signal de zone
                _pave_depart.pave_signal_zone[_cote_depart]   = _pave_boucle;                                                                      //  on a trouve le signal de la zone. Un par cote [2]
                _pave_depart.cote_signal_zone[_cote_depart]   = _cote_courant;
                _pave_depart.coord_signal_zone[_cote_depart]  = _pave_boucle.connecteur[_cote_courant][lames];
            }
        } else {                                                                                                                                   //  il n'y a pas de cible en [1] : on continue en [0] en cherchant un [0]
            signal_mitoyen(_pave_boucle.connecteur[_cote_courant][lames], _pave_boucle, _cote_courant, _pave_depart, _cote_depart, _true_suivant_false_zone);   //  on est en [0], on continue avec l'autre connecteur [1] du pavé en cours
        }                                
    }
}
