//*************************************************** Zautres ******************************************************************
void analyse() {
    for (Pave pave1 : tous_paves) {                                                                                                               //  comparatif deux a deux de toutes les positions des connecteurs :
        for (int i1 = 0; i1 < 2; i1++) {                                                                                                          //  origine et extremite
            pave1.feu_clignotant[i1] = false;
            for (int j1 = 0; j1 < 4; j1++) {                                                                                                      //  jusqu'a 4 formes par pavé
                if (pave1.connecteur[i1][j1].x != 0 && pave1.connecteur[i1][j1].y != 0 && !pave1.feu_clignotant[i1]) {                            //  on ne compare que les connecteurs existants
                    for (Pave pave2 : tous_paves) {                                                                                               //  deuxieme serie de connecteurs
                        for (int i2 = 0; i2 < 2; i2++) {                                                                                          //  origine et extremite
                            for (int j2 = 0; j2 < 4; j2++) {                                                                                      //  jusqu'a 4 formes par pavé
                                if (pave2.connecteur[i2][j2].x != 0 && pave2.connecteur[i2][j2].y != 0) {            //  on ne compare que les connecteurs existants
                                    if (PVector.dist(pave1.connecteur[i1][j1], pave2.connecteur[i2][j2]) < 1.1 && pave1 != pave2) {               //  les connecteurs sont au meme endroit, sur des pavés distincts
                                        pave1.feu_clignotant[i1] = true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    boolean tout_bon = true;
    for (Pave pave1 : tous_paves) {
        pave1.erreur_connecteur = false;
        if (!pave1.feu_clignotant[0]) {
            showMessageDialog(null, "sur le pave "+pave1.c+", "+pave1.l+" il manque un connecteur coté origine",
                                    "Attention", ERROR_MESSAGE);
            pave1.erreur_connecteur = true;
            tout_bon                = false;
        }
        if (!pave1.feu_clignotant[1] && pave1.type != 2) {
            showMessageDialog(null, "sur le pave "+pave1.c+", "+pave1.l+" il manque un connecteur coté extrémité",
                                    "Attention", ERROR_MESSAGE);
            pave1.erreur_connecteur = true;
            tout_bon                = false;
        }
    }
    one_shot = true;
    if (tout_bon) {
        showMessageDialog(null, "Pas d'erreur de connecteurs");
    }
}
